DATA    SEGMENT WORD
	EXTRN   OutSave:WORD
	EXTRN   Printadr:WORD
	EXTRN   PC_Func:BYTE
	EXTRN   Moff:Byte
DATA    ENDS


CODE    SEGMENT
	ASSUME  CS:CODE,DS:DATA


	PUBLIC  Motors_off
	PUBLIC  Motor
	PUBLIC  Analog_Input
	PUBLIC  Input
	PUBLIC  Input_All_Values
	PUBLIC  Input_Byte
	PUBLIC  Output
	PUBLIC  Internal_PCFunc


MOTORS_OFF      PROC    FAR
	XOR   BX,BX
	CALL    SHOUT
	RET
MOTORS_OFF      ENDP

MOTOR   PROC    FAR
	MOV     BX,SP
	MOV     CL,SS:[BX+6]
	DEC     CL
	SHL     CL,1
	MOV     AX,0003H
	SHL     AX,CL
	MOV     CL,SS:[BX+4]
	SUB     BX,BX    
	CMP     CL,0
	JE      MOTOR1
	MOV     BX,05555H
	CMP     CL,1
	JE      MOTOR1
	NOT     BX
	CMP     CL,2
	JE      MOTOR1
	SUB     BX,BX
	DEC     BX
MOTOR1:
	AND     BX,AX
	OR      AX,OutSave
	XOR     BX,AX
	CALL    SHOUT
	RET     4
MOTOR   ENDP
	;-------------------------
SHOUT   PROC    NEAR
	MOV     OutSave,BX
	MOV     CX,16
	MOV     DX,Printadr
	CLI
LO:     MOV     AL,30H
	RCL     BX,1
	JNB     AUS
	OR      AL,04H
AUS:    OUT     DX,AL
	OUT     DX,AL
	OUT     DX,AL
	OR      AL,08H
	OUT     DX,AL
	OUT     DX,AL
	OUT     DX,AL
	LOOP    LO
	MOV     AL,39H
	OUT     DX,AL
	OUT     DX,AL
	STI
	RET
SHOUT   ENDP
	;--------------------
SHIN    PROC    NEAR
	MOV     CX,16
	MOV     AL,32H
	CLI
	OUT     DX,AL
	OUT     DX,AL
	OUT     DX,AL
	OR      AL,8
	OUT     DX,AL
	OUT     DX,AL
	OUT     DX,AL
INP:    INC     DX
	IN      AL,DX
	RCL     AL,1
	RCL     SI,1
	DEC     DX
	MOV     AL,30H
	OUT     DX,AL
	OUT     DX,AL
	OUT     DX,AL
	OR      AL,8
	OUT     DX,AL
	OUT     DX,AL
	OUT     DX,AL
	LOOP    INP
	STI
	RET
SHIN    ENDP

	;--------------------------
INPUT   PROC    FAR
	MOV     BX,SP
	MOV     AH,SS:[BX+4]
	MOV     DX,Printadr
	CALL    SHIN
	MOV     CL,AH
	DEC     CL
	MOV     AX,1
	SHL     AX,CL
	XCHG    AL,AH
	AND     AX,SI
	JZ      OUTP
	MOV     AL,1
OUTP:
	RET     2
INPUT   ENDP
	;------------------------------
INPUT_ALL_VALUES PROC   FAR
	MOV     BX,SP
	LES     DI,SS:[BX+4]
	MOV     DX,Printadr
	CALL    SHIN
	MOV     CX,16
	MOV     AX,SI
	XCHG    AH,AL
	MOV     SI,AX
BITSCH:
	XOR     AL,AL
	RCR     SI,1
	RCL     AL,1
	STOSB
	LOOP    BITSCH
	RET     4
INPUT_ALL_VALUES ENDP
	;------------------------------
INPUT_BYTE      PROC    FAR
	MOV     DX,Printadr
	CALL    SHIN
	MOV     AX,SI
	XCHG    AH,AL
	RET
INPUT_BYTE      ENDP
	;------------------------------
OUTPUT  PROC    FAR
	MOV     BX,SP
	MOV     CL,SS:[bx+6]
	MOV     AL,SS:[bx+4]
	MOV     AH,0
	MOV     DX,1
	DEC     CL
	SHL     AX,CL
	SHL     DX,CL
	MOV     BX,OutSave
	NOT     DX
	AND     BX,DX
	OR      BX,AX
	CALL    shout
	RET     4
OUTPUT  ENDP
	;------------------------------
ANALOG_INPUT    PROC    FAR
	MOV     BX,SP
	MOV     AH,SS:[BX+4]
	MOV     BL,144
	CMP     AH,1
	JZ      PODI1
	ADD     BL,16
PODI1:
	MOV     AX,450
	MOV     CL,PC_Func
	XOR     CH,CH
	MOV     DI,CX
	CMP     CL,1
	JZ      PODI2
	XOR     DX,DX
	MUL     CX
PODI2:
	MOV     CX,AX
	MOV     SI,AX
	MOV     DX,Printadr
	MOV     AL,BL
	CLI
	OUT     DX,AL
	OUT     DX,AL
	OUT     DX,AL
	MOV     AL,38H
	OUT     DX,AL
	OUT     DX,AL
	OUT     DX,AL
	INC     DX
	MOV     AH,80H
CIN:    IN      AL,DX
	AND     AL,AH
	LOOPNZ  CIN
	STI
	MOV     BX,CX
	XOR     CX,CX
CIN1:   IN      AL,DX
	AND     AL,AH
	LOOPNZ  CIN1
	MOV     AX,SI
	MOV     CX,DI
	SUB     AX,BX
	CMP     CL,1
	JZ      PODI3
	XOR     DX,DX
	DIV     CX
PODI3:    
	RET     2
ANALOG_INPUT    ENDP


INTERNAL_PCFUNC PROC    FAR
	MOV     BX,SP
	MOV     AH,SS:[BX+4]
PCW0:
	PUSH    BX
	CALL    ANALOG_INSTALL
	POP     BX
PCW3:
	MOV     AX,CX
	MOV     CX,450
	XOR     DX,DX
	DIV     CX
	INC     AX
	RET     2

ANALOG_INSTALL  PROC    NEAR
	MOV     BL,144
	CMP     AH,1
	JZ      PODI10
	ADD     BL,16
PODI10:
	XOR     CX,CX
	MOV     DX,Printadr
	MOV     AL,BL
	CLI
	OUT     DX,AL
	OUT     DX,AL
	OUT     DX,AL
	MOV     AL,38H
	OUT     DX,AL
	OUT     DX,AL
	OUT     DX,AL
	INC     DX
	MOV     AH,80H
CIN0:   IN      AL,DX
	AND     AL,AH
	LOOPNZ  CIN0
	STI
	MOV     BX,CX
	XOR     CX,CX
CIN10:  IN      AL,DX
	AND     AL,AH
	LOOPNZ  CIN10
	MOV     CX,BX
	NOT     CX
	RET
ANALOG_INSTALL  ENDP
INTERNAL_PCFUNC ENDP

CODE    ENDS
	END
